/****************************************************************************
**
** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
** All rights reserved.
** Contact: Nokia Corporation (qt-info@nokia.com)
**
** This file is part of the Qt Mobility Components.
**
** $QT_BEGIN_LICENSE:LGPL$
** No Commercial Usage
** This file contains pre-release code and may not be distributed.
** You may use this file in accordance with the terms and conditions
** contained in the Technology Preview License Agreement accompanying
** this package.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 2.1 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU Lesser General Public License version 2.1 requirements
** will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Nokia gives you certain additional
** rights.  These rights are described in the Nokia Qt LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
** If you have questions regarding the use of this file, please contact
** Nokia at qt-info@nokia.com.
**
**
**
**
**
**
**
**
** $QT_END_LICENSE$
**
****************************************************************************/

#include "pulseaudioplayerservice.h"
#include "pulseaudioserviceproviderplugin.h"


QStringList PulseaudioServiceProviderPlugin::keys() const
{
    return QStringList() << Q_MEDIASERVICE_MEDIAPLAYER;
}

QMediaService* PulseaudioServiceProviderPlugin::create(const QString &key)
{
    if (key == QLatin1String(Q_MEDIASERVICE_MEDIAPLAYER))
        return new PulseAudioPlayerService;

    return 0;
}

void PulseaudioServiceProviderPlugin::release(QMediaService *service)
{
    delete service;
}

QMediaServiceProviderHint::Features PulseaudioServiceProviderPlugin::supportedFeatures(const QByteArray &service) const
{
    if (service == QByteArray(Q_MEDIASERVICE_MEDIAPLAYER))
        return QMediaServiceProviderHint::LowLatencyPlayback;

    return 0;
}

QtMedia::SupportEstimate PulseaudioServiceProviderPlugin::hasSupport(const QString &mimeType, const QStringList& codecs) const
{
    Q_UNUSED(codecs);

    if (mimeType == QLatin1String("audio/x-wav"))
        return QtMedia::ProbablySupported;

    return QtMedia::NotSupported;
}

QStringList PulseaudioServiceProviderPlugin::supportedMimeTypes() const
{
    return QStringList() << QLatin1String("audio/x-wav");
}


Q_EXPORT_PLUGIN2(pulseaudio_serviceplugin, PulseaudioServiceProviderPlugin);
